//EMP Rifle
//Stuns vehicles and doesn't afraid of anything.

//audio
datablock AudioProfile(EMPShotSound)
{
	filename    = "./EMPShot.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(EMPHitSound)
{
	filename    = "./EMPExplosion.wav";
	description = Audiodefault3d;
	preload = true;
};

if(!isObject(JeepDebris))
{
	datablock ParticleData(jeepDebrisTrailParticle)
	{
		dragCoefficient		= 3.0;
		windCoefficient		= 0.0;
		gravityCoefficient	= -0.5;
		inheritedVelFactor	= 0.0;
		constantAcceleration	= 0.0;
		lifetimeMS		= 600;
		lifetimeVarianceMS	= 150;
		spinSpeed		= 10.0;
		spinRandomMin		= -50.0;
		spinRandomMax		= 50.0;
		useInvAlpha		= true;
		animateTexture		= false;
		//framesPerSec		= 1;

		textureName		= "base/data/particles/cloud";
		//animTexName		= "~/data/particles/cloud";

		// Interpolation variables
		colors[0]	= "0.0 0.0 0.0 0.5";
		colors[1]	= "0.0 0.0 0.0 1.0";
		colors[2]	= "0.0 0.0 0.0 0.0";

		sizes[0]	= 2.0;
		sizes[1]	= 5.0;
		sizes[2]	= 5.0;

		times[0]	= 0.0;
		times[1]	= 0.1;
		times[2]	= 1.0;
	};
	datablock ParticleEmitterData(jeepDebrisTrailEmitter)
	{
		ejectionPeriodMS = 15;
		periodVarianceMS = 0;
		ejectionVelocity = 8;
		velocityVariance = 1.0;
		ejectionOffset   = 1.0;
		thetaMin         = 40;
		thetaMax         = 90;
		phiReferenceVel  = 0;
		phiVariance      = 360;
		overrideAdvance = false;
		particles = "jeepDebrisTrailParticle";

		uiName = "Jeep Debris Trail";
		emitterNode = FifthEmitterNode;
	};
}
//shell
datablock DebrisData(EMPShellDebris)
{
	shapeFile = "./EMPShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	emitter = jeepDebrisTrailEmitter;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(EMPRifleFlashParticle)
{
	dragCoefficient      = 0.5;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 45;
	lifetimeVarianceMS   = 3;
	textureName          = "base/data/particles/thinring";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.2 0.2 0.9 0.9";
	colors[1]     = "0.2 0.3 0.9 0.0";
	sizes[0]      = 0.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(EMPRifleFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = true;
   particles = "EMPRifleFlashParticle";

   uiName = "EMP Flash";
};

datablock ParticleData(EMPRifleSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.7 0.6";
	colors[1]     = "0.5 0.5 0.6 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.55;

	useInvAlpha = false;
};
datablock ParticleEmitterData(EMPRifleSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "EMPRifleSmokeParticle";

   uiName = "EMP Muzzle Smoke";
};


datablock ParticleData(EMPExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1600;
	lifetimeVarianceMS   = 700;
	textureName          = "./triangle";
	spinSpeed		= 600.0;
	spinRandomMin		= -360.0;
	spinRandomMax		= 360.0;
	colors[0]     = "0.1 0.1 1.0 0.9";
	colors[1]     = "0.2 0.2 1.0 0.0";
	sizes[0]      = 1.9;
	sizes[1]      = 0.9;

	useInvAlpha = true;
};

datablock ParticleEmitterData(EMPRifleExplosionEmitter) //Energy clouds of something.
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 105;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "EMPExplosionParticle";

   uiName = "EMP Hit Sparks";
};

datablock ParticleData(EMPTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1300;
	lifetimeVarianceMS   = 200;
	textureName          = "./triangle";
	spinSpeed		= 800.0;
	spinRandomMin		= -180.0;
	spinRandomMax		= 180.0;
	colors[0]     = "0.2 0.1 0.9 0.9";
	colors[1]     = "0.4 0.2 0.85 0.0";
	sizes[0]      = 1.7;
	sizes[1]      = 0.7;

	useInvAlpha = true;
};

datablock ParticleEmitterData(EMPTrailEmitter) //Energy trail clouds of something.
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles[0] = "EMPTrailParticle";
   particles[1] = "EMPrifleflashParticle";
};

datablock ParticleData(EMPElectricParticle)
{
	dragCoefficient      = 0.6;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 370;
	lifetimeVarianceMS   = 120;
	textureName          = "add-ons/projectile_radio_wave/bolt";
	spinSpeed		= 10.0;
	spinRandomMin		= -300.0;
	spinRandomMax		= 300.0;
	colors[0]     = "0.2 0.2 0.95 0.9";
	colors[1]     = "0.3 0.3 0.8 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.9;

	useInvAlpha = false;
};
datablock ParticleEmitterData(EMPElectricEmitter)
{
	lifeTimeMS = 120;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.7;
   velocityVariance = 0.0;
   ejectionOffset   = 1.5;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "EMPElectricParticle";

   uiName = "EMP Zap";
};

datablock ExplosionData(EMPExplosion)
{
   //explosionShape = "";
	soundProfile = EMPHitSound;

   lifeTimeMS = 230;

   particleEmitter = EMPElectricEmitter;
   particleDensity = 36;
   particleRadius = 0.4;

   emitter[0] = EMPRifleExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 4;
   lightStartColor = "0.2 0.2 0.9";
   lightEndColor = "0 0 0";
};


datablock ProjectileData(EMPProjectile)
{
   projectileShapeName = "";
   directDamage        = 1;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = EMPExplosion;
   particleEmitter     = EMPTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0.1;

   armingDelay         = 0;
   lifetime            = 2500;
   fadeDelay           = 2500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.7 0.5 0";

   uiName = "EMP Jolt";
};

//////////
// item //
//////////
datablock ItemData(EMPRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./EMPR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "EMP Rifle";
	iconName = "./icon_EMP";
	doColorShift = false;
	colorShiftColor = "0.0 0.0 1.0 1.000";

	 // Dynamic properties defined by the scripts
	image = EMPRifleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(EMPRifleImage)
{
   // Basic Item properties
   shapeFile = "./EMPR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = EMPRifleItem;
   ammo = " ";
   projectile = EMPProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 2000; //Needed to prevent faggots from q-qing.

   doColorShift = true;
   colorShiftColor = EMPRifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateSequence[0]= "Activate";	
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= EMPRifleFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= EMPShotSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= EMPRifleSmokeEmitter;
	stateEmitterTime[3]				= 2;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 2;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function EMPProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.getType() & $TypeMasks::VehicleObjectType) //%col.getType() & $TypeMasks::PlayerObjectType || Taken out because bots take precedence over players and I'm short on time.
	{
		if(%col.isMounted())
		{
			EMPProjectile::Damage(%this,%obj,%col.getobjectmount(),%fade,%pos,%normal);
			return;
		}
		if(%col.getType() & $TypeMasks::VehicleObjectType) //(%col.getdatablock().rideable && %col.gettype() & $typemasks::playerobjecttype) || 
		{
			EMPEjectAllPlayers(%col);
			EMPStun(%col);
			if(%col.stunSimTime + 5000 >= getsimtime())
				%col.damage(%obj, 0, 40, $DamageType::Direct);
			else
				%col.damage(%obj, 0, 20, $DamageType::Direct);
		}
	}
}

function EMPEjectAllPlayers(%veh)
{
	for(%i=0;%i<%veh.getDatablock().numMountPoints;%i++)
	{
		%obj = %veh.getMountedObject(0);
		if(!isObject(%obj))
			continue;
		if(%obj.getdatablock().numMountPoints)
		{
			EMPEjectAllPlayers(%obj);
			continue;
		}
		if(%obj.dontEject)
			continue;
		%obj.dismount();
		%obj.addVelocity(vectorscale(vectorNormalize(vectorSub(%obj.getposition(), %veh.getPosition())), 12));
	}
}

function EMPStun(%veh)
{
	%veh.stunSimTime = getsimtime();
	%seatblocker = new AIPlayer() 
	{
		dataBlock = PlayerStandardArmor;
		dontEject = true;
	};
	missioncleanup.add(%seatblocker);
	%seatblocker.hidenode("ALL");
	//%seatblocker.setInvincibleMode(5000, 1); //God damnit this broke when v13 came out, and without a changelog I'm going to assume v13 broke this.
	%veh.mountObject(%seatblocker, 0);
	%seatblocker.schedule(5000, delete);
	%p = new ParticleEmitterNode()
	{
		datablock = genericEmitterNode;
		emitter = EMPElectricEmitter;
		position = %veh.gettransform();
		normal = 0;
	};
	missionCleanup.Add(%p);
	%seatblocker.mountobject(%p,0);
	%p.setScale( mAbs(getWord(%veh.getobjectbox(),0) - getWord(%veh.getobjectBox(), 3)) SPC mAbs(getWord(%veh.getobjectbox(),1) - getWord(%veh.getobjectBox(), 4)) SPC mAbs(getWord(%veh.getobjectbox(),2) - getWord(%veh.getobjectBox(), 5)));
	%p.schedule(5000, delete);
	schedule(100, 0, moveEMPSparks, %veh, %p);
}

function moveEmpSparks(%veh, %EMPSparks)
{
	if(!isobject(%EMPSparks) || !isObject(%veh))
		return;
	echo(%veh.getPosition());
	%empSparks.setTransform(%veh.getPosition());
	%empSparks.setscale(%empSparks.getScale()); //Because torque is stupid like that.
	schedule(100, 0, moveEMPSparks, %veh, %empSparks);
}